# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class GetDatabaseClusterResult:
    """
    A collection of values returned by getDatabaseCluster.
    """
    def __init__(__self__, database=None, engine=None, host=None, maintenance_windows=None, name=None, node_count=None, port=None, region=None, size=None, uri=None, urn=None, user=None, version=None, id=None):
        if database and not isinstance(database, str):
            raise TypeError("Expected argument 'database' to be a str")
        __self__.database = database
        """
        Name of the cluster's default database.
        """
        if engine and not isinstance(engine, str):
            raise TypeError("Expected argument 'engine' to be a str")
        __self__.engine = engine
        """
        Database engine used by the cluster (ex. `pg` for PostreSQL).
        """
        if host and not isinstance(host, str):
            raise TypeError("Expected argument 'host' to be a str")
        __self__.host = host
        """
        Database cluster's hostname.
        """
        if maintenance_windows and not isinstance(maintenance_windows, list):
            raise TypeError("Expected argument 'maintenance_windows' to be a list")
        __self__.maintenance_windows = maintenance_windows
        """
        Defines when the automatic maintenance should be performed for the database cluster.
        """
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        __self__.name = name
        if node_count and not isinstance(node_count, float):
            raise TypeError("Expected argument 'node_count' to be a float")
        __self__.node_count = node_count
        """
        Number of nodes that will be included in the cluster.
        """
        if port and not isinstance(port, float):
            raise TypeError("Expected argument 'port' to be a float")
        __self__.port = port
        """
        Network port that the database cluster is listening on.
        """
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        __self__.region = region
        """
        DigitalOcean region where the cluster will reside.
        """
        if size and not isinstance(size, str):
            raise TypeError("Expected argument 'size' to be a str")
        __self__.size = size
        """
        Database droplet size associated with the cluster (ex. `db-s-1vcpu-1gb`).
        """
        if uri and not isinstance(uri, str):
            raise TypeError("Expected argument 'uri' to be a str")
        __self__.uri = uri
        """
        The full URI for connecting to the database cluster.
        """
        if urn and not isinstance(urn, str):
            raise TypeError("Expected argument 'urn' to be a str")
        __self__.urn = urn
        """
        The uniform resource name of the database cluster.
        """
        if user and not isinstance(user, str):
            raise TypeError("Expected argument 'user' to be a str")
        __self__.user = user
        """
        Username for the cluster's default user.
        """
        if version and not isinstance(version, str):
            raise TypeError("Expected argument 'version' to be a str")
        __self__.version = version
        """
        Engine version used by the cluster (ex. `11` for PostgreSQL 11).
        """
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        __self__.id = id
        """
        id is the provider-assigned unique ID for this managed resource.
        """
class AwaitableGetDatabaseClusterResult(GetDatabaseClusterResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDatabaseClusterResult(
            database=self.database,
            engine=self.engine,
            host=self.host,
            maintenance_windows=self.maintenance_windows,
            name=self.name,
            node_count=self.node_count,
            port=self.port,
            region=self.region,
            size=self.size,
            uri=self.uri,
            urn=self.urn,
            user=self.user,
            version=self.version,
            id=self.id)

def get_database_cluster(name=None,opts=None):
    """
    Provides information on a DigitalOcean database cluster resource.
    
    :param str name: The name of the database cluster.

    > This content is derived from https://github.com/terraform-providers/terraform-provider-digitalocean/blob/master/website/docs/d/database_cluster.html.markdown.
    """
    __args__ = dict()

    __args__['name'] = name
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = utilities.get_version()
    __ret__ = pulumi.runtime.invoke('digitalocean:index/getDatabaseCluster:getDatabaseCluster', __args__, opts=opts).value

    return AwaitableGetDatabaseClusterResult(
        database=__ret__.get('database'),
        engine=__ret__.get('engine'),
        host=__ret__.get('host'),
        maintenance_windows=__ret__.get('maintenanceWindows'),
        name=__ret__.get('name'),
        node_count=__ret__.get('nodeCount'),
        port=__ret__.get('port'),
        region=__ret__.get('region'),
        size=__ret__.get('size'),
        uri=__ret__.get('uri'),
        urn=__ret__.get('urn'),
        user=__ret__.get('user'),
        version=__ret__.get('version'),
        id=__ret__.get('id'))
